﻿using System;
using System.Collections.Generic;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Threading;
using System.Windows.Forms;
using AddinExpress.MSO;
using Freshbooks.Library;
using Freshbooks.Library.Model;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace Freshbooks_Addin
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("7148F9BB-DDF3-4F43-894F-2405CD41D0A5"), ProgId("Freshbooks_Addin.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }
        private ImageList iml16x16Icons;
        private ADXOLSolutionModule freshbooksSolutionModule;
        private ADXRibbonTab adxFreshbooksRibbonTab;
        private ADXRibbonGroup adxRibbonGroup2;
        private ADXRibbonButton adxImportClientsRibbonButton;
        private ImageList iml32x32Icons;
        private ADXRibbonButton adxImportInvoicesRibbonButton;
        private AddinExpress.OL.ADXOlFormsManager freshbooksFormsManager;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.iml16x16Icons = new System.Windows.Forms.ImageList(this.components);
            this.freshbooksSolutionModule = new AddinExpress.MSO.ADXOLSolutionModule(this.components);
            this.adxFreshbooksRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup2 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxImportClientsRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.iml32x32Icons = new System.Windows.Forms.ImageList(this.components);
            this.adxImportInvoicesRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.freshbooksFormsManager = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            // 
            // iml16x16Icons
            // 
            this.iml16x16Icons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("iml16x16Icons.ImageStream")));
            this.iml16x16Icons.TransparentColor = System.Drawing.Color.Transparent;
            this.iml16x16Icons.Images.SetKeyName(0, "freshbooks");
            this.iml16x16Icons.Images.SetKeyName(1, "clients");
            this.iml16x16Icons.Images.SetKeyName(2, "staff");
            this.iml16x16Icons.Images.SetKeyName(3, "invoice");
            this.iml16x16Icons.Images.SetKeyName(4, "project");
            this.iml16x16Icons.Images.SetKeyName(5, "task");
            this.iml16x16Icons.Images.SetKeyName(6, "timesheet");
            // 
            // adxFreshbooksRibbonTab
            // 
            this.adxFreshbooksRibbonTab.Caption = "Freshbooks";
            this.adxFreshbooksRibbonTab.Controls.Add(this.adxRibbonGroup2);
            this.adxFreshbooksRibbonTab.Id = "adxRibbonTab_b3e50cf211904199836f12db0951c596";
            this.adxFreshbooksRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup2
            // 
            this.adxRibbonGroup2.Caption = "Import";
            this.adxRibbonGroup2.Controls.Add(this.adxImportClientsRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.adxImportInvoicesRibbonButton);
            this.adxRibbonGroup2.Id = "adxRibbonGroup_5d4cf3ffbd794c2f8b6ae9bd51927e22";
            this.adxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxImportClientsRibbonButton
            // 
            this.adxImportClientsRibbonButton.Caption = "Clients";
            this.adxImportClientsRibbonButton.Id = "adxRibbonButton_7dc53818484c41dcb1465e10c6f9272d";
            this.adxImportClientsRibbonButton.Image = 0;
            this.adxImportClientsRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportClientsRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportClientsRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportClientsRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // iml32x32Icons
            // 
            this.iml32x32Icons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("iml32x32Icons.ImageStream")));
            this.iml32x32Icons.TransparentColor = System.Drawing.Color.Transparent;
            this.iml32x32Icons.Images.SetKeyName(0, "clients");
            this.iml32x32Icons.Images.SetKeyName(1, "invoice");
            this.iml32x32Icons.Images.SetKeyName(2, "project");
            // 
            // adxImportInvoicesRibbonButton
            // 
            this.adxImportInvoicesRibbonButton.Caption = "Invoices";
            this.adxImportInvoicesRibbonButton.Id = "adxRibbonButton_3496ddcc88454f778d4defee4b911e14";
            this.adxImportInvoicesRibbonButton.Image = 1;
            this.adxImportInvoicesRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportInvoicesRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportInvoicesRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportInvoicesRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxImportInvoicesRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxImportInvoicesRibbonButton_OnClick);
            // 
            // freshbooksFormsManager
            // 
            this.freshbooksFormsManager.Items.Add(this.adxOlFormsCollectionItem1);
            this.freshbooksFormsManager.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.FormClassName = "Freshbooks_Addin.frmInvoice";
            this.adxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olJournal;
            this.adxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.CompleteReplacement;
            this.adxOlFormsCollectionItem1.InspectorMessageClass = "IPM.Journal.Freshbooks.Invoice";
            this.adxOlFormsCollectionItem1.UseOfficeThemeForBackground = true;
            // 
            // AddinModule
            // 
            this.AddinName = "Freshbooks_Addin";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Outlook._NameSpace session = OutlookApp.GetNamespace("MAPI");
            Outlook._Store defaultStore = session.DefaultStore;
            Outlook.Folder rootFolder = defaultStore.GetRootFolder() as Outlook.Folder;
            Outlook.Folder freshbooksFolder = freshbooksFolder = GetFolder(rootFolder.FolderPath + @"\Freshbooks");
            if (freshbooksFolder != null)
                freshbooksFolder.Delete();

            if (freshbooksFolder != null) Marshal.ReleaseComObject(freshbooksFolder);
            if (rootFolder != null) Marshal.ReleaseComObject(rootFolder);
            if (defaultStore != null) Marshal.ReleaseComObject(defaultStore);
            if (session != null) Marshal.ReleaseComObject(session);

            CreateFreshbooksFolders();
            CreateSolutionModuleLayout();
        }

        private void CreateFreshbooksFolders()
        {
            Outlook._NameSpace session = null;
            Outlook._Store defaultStore = null;
            Outlook.Folder rootFolder = null;

            Outlook.Folder freshbooksFolder = null;
            Outlook.Folders rootFolders = null;

            try
            {
                session = OutlookApp.GetNamespace("MAPI");
                defaultStore = session.DefaultStore;
                rootFolder = defaultStore.GetRootFolder() as Outlook.Folder;

                freshbooksFolder = GetFolder(rootFolder.FolderPath + @"\Freshbooks");
                if (freshbooksFolder == null)
                {
                    rootFolders = rootFolder.Folders;
                    freshbooksFolder = rootFolders.Add("Freshbooks", Outlook.OlDefaultFolders.olFolderInbox) as Outlook.Folder;

                    CreateFolder(freshbooksFolder, "Clients", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Client", "Client", true);
                    CreateClientView(GetFolder(freshbooksFolder.FolderPath + "\\Clients"));

                    CreateFolder(freshbooksFolder, "Invoices", Outlook.OlDefaultFolders.olFolderJournal, "IPM.Journal.Freshbooks.Invoice", "Invoice");
                    AddInvoiceFields(GetFolder(freshbooksFolder.FolderPath + "\\Invoices"));
                    CreateInvoiceView(GetFolder(freshbooksFolder.FolderPath + "\\Invoices"));

                    CreateFolder(freshbooksFolder, "Staff", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Staff", "Team Member", true);
                    CreateFolder(freshbooksFolder, "Projects", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Project", "Project", true);
                    CreateFolder(freshbooksFolder, "Tasks", Outlook.OlDefaultFolders.olFolderTasks, "IPM.Task.Freshbooks.Task", "Task");
                    CreateFolder(freshbooksFolder, "Timesheets", Outlook.OlDefaultFolders.olFolderCalendar, "IPM.Appointment.Freshbooks.Timesheet", "Timesheet");
                }
            }
            finally
            {
                if (rootFolders != null) Marshal.ReleaseComObject(rootFolders);
                if (freshbooksFolder != null) Marshal.ReleaseComObject(freshbooksFolder);
                if (rootFolder != null) Marshal.ReleaseComObject(rootFolder);
                if (defaultStore != null) Marshal.ReleaseComObject(defaultStore);
                if (session != null) Marshal.ReleaseComObject(session);
            }
        }

        private void CreateSolutionModuleLayout()
        {
            ADXOLSolutionFolder freshbooksFolder = new ADXOLSolutionFolder
            {
                FolderName = "Freshbooks",
                FolderType = ADXOLSolutionFolderType.Inbox,
                ImageList = iml16x16Icons,
                Image = 0
            };

            ADXOLSolutionFolder freshbooksClientsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Clients",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 1
            };

            ADXOLSolutionFolder freshbooksStaffFolder = new ADXOLSolutionFolder
            {
                FolderName = "Staff",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 2
            };

            ADXOLSolutionFolder freshbooksInvoiceFolder = new ADXOLSolutionFolder
            {
                FolderName = "Invoices",
                FolderType = ADXOLSolutionFolderType.Journal,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 3
            };

            ADXOLSolutionFolder freshbooksProjectsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Projects",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 4
            };

            ADXOLSolutionFolder freshbooksTasksFolder = new ADXOLSolutionFolder
            {
                FolderName = "Tasks",
                FolderType = ADXOLSolutionFolderType.Tasks,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 5
            };

            ADXOLSolutionFolder freshbooksTimesheetsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Timesheets",
                FolderType = ADXOLSolutionFolderType.Calendar,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 6
            };

            freshbooksFolder.Folders.Add(freshbooksClientsFolder);
            freshbooksFolder.Folders.Add(freshbooksStaffFolder);
            freshbooksFolder.Folders.Add(freshbooksInvoiceFolder);
            freshbooksFolder.Folders.Add(freshbooksProjectsFolder);
            freshbooksFolder.Folders.Add(freshbooksTasksFolder);
            freshbooksFolder.Folders.Add(freshbooksTimesheetsFolder);
            freshbooksSolutionModule.Folders.Add(freshbooksFolder);
        }

        //http://www.add-in-express.com/creating-addins-blog/2012/04/09/customize-outlook-views-programmatically/
        private void CreateClientView(Outlook.Folder folder)
        {
            Outlook._Views folderViews = null;
            Outlook._TableView tableView = null;
            Outlook._ViewFields viewFields = null;

            //Outlook._ViewField firstNameField = null;
            //Outlook._ColumnFormat firstNameFieldFormat = null;
            //Outlook._ViewField lastNameField = null;
            //Outlook._ColumnFormat lastNameFieldFormat = null;
            //Outlook._ViewField workPhoneField = null;
            //Outlook._ColumnFormat workPhoneFieldFormat = null;

            try
            {
                folderViews = folder.Views;
                tableView = folderViews.Add("Freshbooks Clients", Outlook.OlViewType.olTableView, Outlook.OlViewSaveOption.olViewSaveOptionThisFolderEveryone) as Outlook._TableView;
                tableView.XML = Properties.Settings.Default.EmptyViewXml;
                tableView.ShowNewItemRow = false;
                tableView.AutomaticColumnSizing = true;
                tableView.AllowInCellEditing = false;

                viewFields = tableView.ViewFields;
                //// First Name
                //firstNameField = viewFields["urn:schemas:contacts:cn"];
                //firstNameFieldFormat = firstNameField.ColumnFormat;
                //firstNameFieldFormat.Label = "First Name";
                //// Last Name
                //lastNameField = viewFields["urn:schemas:contacts:sn"];
                //lastNameFieldFormat = lastNameField.ColumnFormat;
                //lastNameFieldFormat.Label = "Last Name";
                //// Work Phone
                //workPhoneField = viewFields["urn:schemas:contacts:office2telephonenumber"];
                //workPhoneFieldFormat = workPhoneField.ColumnFormat;
                //workPhoneFieldFormat.Label = "Work Phone";

                tableView.Save();
                tableView.Apply();
            }
            finally
            {
                //if (firstNameFieldFormat != null) Marshal.ReleaseComObject(firstNameFieldFormat);
                //if (firstNameField != null) Marshal.ReleaseComObject(firstNameField);
                //if (lastNameFieldFormat != null) Marshal.ReleaseComObject(lastNameFieldFormat);
                //if (lastNameField != null) Marshal.ReleaseComObject(lastNameField);
                //if (workPhoneFieldFormat != null) Marshal.ReleaseComObject(workPhoneFieldFormat);
                //if (workPhoneField != null) Marshal.ReleaseComObject(workPhoneField);
                if (viewFields != null) Marshal.ReleaseComObject(viewFields);
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void AddInvoiceFields(Outlook.Folder folder)
        {
            AddPropertyToFolder(folder, "fb-clientid", Outlook.OlUserPropertyType.olNumber);
            AddPropertyToFolder(folder, "fb-invoicenumber", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-clientname", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-status", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-date", Outlook.OlUserPropertyType.olDateTime);
            AddPropertyToFolder(folder, "fb-ponumber", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-amount", Outlook.OlUserPropertyType.olCurrency);
            AddPropertyToFolder(folder, "fb-linesXML", Outlook.OlUserPropertyType.olText);
        }

        private void AddPropertyToFolder(Outlook.Folder folder, string propertyName, Outlook.OlUserPropertyType propertyType)
        {
            Outlook._UserDefinedProperties userProperties = null;
            Outlook._UserDefinedProperty userProperty = null;

            try
            {
                userProperties = folder.UserDefinedProperties;
                userProperty = userProperties.Find(propertyName);
                if (userProperty == null)
                    userProperty = userProperties.Add(propertyName, propertyType);
            }
            finally
            {
                if (userProperty != null) Marshal.ReleaseComObject(userProperty);
                if (userProperties != null) Marshal.ReleaseComObject(userProperties);
            }
        }

        private void CreateInvoiceView(Outlook.Folder folder)
        {
            Outlook._Views folderViews = null;
            Outlook._TableView tableView = null;
            Outlook._ViewFields viewFields = null;

            Outlook._ViewField clientIdField = null;
            Outlook._ColumnFormat clientIdFieldFormat = null;

            Outlook._ViewField invoiceNumberField = null;
            Outlook._ColumnFormat invoiceNumberFieldFormat = null;

            Outlook._ViewField statusField = null;
            Outlook._ColumnFormat statusFieldFormat = null;

            Outlook._ViewField dateField = null;
            Outlook._ColumnFormat dateFieldFormat = null;

            Outlook._ViewField poNumberField = null;
            Outlook._ColumnFormat poNumberFieldFormat = null;

            Outlook._ViewField termsField = null;
            Outlook._ColumnFormat termsFieldFormat = null;

            try
            {
                folderViews = folder.Views;
                tableView = folderViews.Add("Freshbooks Invoices", Outlook.OlViewType.olTableView, 
                    Outlook.OlViewSaveOption.olViewSaveOptionThisFolderEveryone) as Outlook._TableView;
                tableView.XML = Properties.Settings.Default.EmptyJournalViewXml;
                tableView.ShowNewItemRow = false;
                tableView.AutomaticColumnSizing = true;
                tableView.AllowInCellEditing = false;

                viewFields = tableView.ViewFields;

                // Client Id
                clientIdField = viewFields.Add("fb-clientid");
                clientIdFieldFormat = clientIdField.ColumnFormat;
                clientIdFieldFormat.Label = "Client Id";

                // Invoice Number
                invoiceNumberField = viewFields.Add("fb-invoicenumber");
                invoiceNumberFieldFormat = invoiceNumberField.ColumnFormat;
                invoiceNumberFieldFormat.Label = "Invoice Number";

                // Status
                statusField = viewFields.Add("fb-status");
                statusFieldFormat = statusField.ColumnFormat;
                statusFieldFormat.Label = "Status";

                // Date
                dateField = viewFields.Add("fb-date");
                dateFieldFormat = dateField.ColumnFormat;
                dateFieldFormat.Label = "Date";

                // PO Number
                poNumberField = viewFields.Add("fb-ponumber");
                poNumberFieldFormat = poNumberField.ColumnFormat;
                poNumberFieldFormat.Label = "PO Number";

                // Terms
                termsField = viewFields.Add("fb-amount");
                termsFieldFormat = termsField.ColumnFormat;
                termsFieldFormat.Label = "Amount";

                //Remove unused view fields
                //  Icon
                viewFields.Remove("http://schemas.microsoft.com/mapi/proptag/0x0fff0102");

                tableView.Save();
                tableView.Apply();
            }
            finally
            {
                if (termsFieldFormat != null) Marshal.ReleaseComObject(termsFieldFormat);
                if (termsField != null) Marshal.ReleaseComObject(termsField);
                if (poNumberFieldFormat != null) Marshal.ReleaseComObject(poNumberFieldFormat);
                if (poNumberField != null) Marshal.ReleaseComObject(poNumberField);
                if (dateFieldFormat != null) Marshal.ReleaseComObject(dateFieldFormat);
                if (dateField != null) Marshal.ReleaseComObject(dateField);
                if (statusFieldFormat != null) Marshal.ReleaseComObject(statusFieldFormat);
                if (statusField != null) Marshal.ReleaseComObject(statusField);
                if (invoiceNumberFieldFormat != null) Marshal.ReleaseComObject(invoiceNumberFieldFormat);
                if (invoiceNumberField != null) Marshal.ReleaseComObject(invoiceNumberField);
                if (clientIdFieldFormat != null) Marshal.ReleaseComObject(clientIdFieldFormat);
                if (clientIdField != null) Marshal.ReleaseComObject(clientIdField);
                if (viewFields != null) Marshal.ReleaseComObject(viewFields);
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void CreateFolder(Outlook.Folder rootFolder, string folderName, Outlook.OlDefaultFolders folderType, string messageClass, string displayName, bool markAsAddressBook = false)
        {
            Outlook.Folder folder = null;
            Outlook.Folders folders = null;
            Outlook._PropertyAccessor propertyAccessor = null;

            try
            {
                folder = GetFolder(rootFolder.FolderPath + "\\" + folderName);

                if (folder == null)
                {
                    folders = rootFolder.Folders;
                    folder = folders.Add(folderName, folderType) as Outlook.Folder;
                    folder.ShowAsOutlookAB = markAsAddressBook;
                    folder.CustomViewsOnly = true;
                    propertyAccessor = folder.PropertyAccessor;
                    propertyAccessor.SetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F", messageClass);
                    propertyAccessor.SetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E6001E", displayName);
                }
            }
            finally
            {
                if (folder != null) Marshal.ReleaseComObject(folder);
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folders != null) Marshal.ReleaseComObject(folders);
            }
        }

        public Outlook.Folder GetFolder(string folderPath)
        {
            Outlook._Application outlookApp = null;
            Outlook.Folder returnFolder = null;
            Outlook.Folders subFolders = null;
            Outlook.NameSpace session = null;
            Outlook.Folders sessionFolders = null;

            try
            {
                outlookApp = AddinModule.CurrentInstance.OutlookApp;
                session = outlookApp.Session;
                folderPath = folderPath.TrimStart("\\".ToCharArray());

                String[] folders = folderPath.Split("\\".ToCharArray());
                sessionFolders = session.Folders;
                returnFolder = sessionFolders[folders[0]] as Outlook.Folder;


                if (returnFolder != null)
                {
                    String folderName;
                    for (int i = 1; i < folders.Length; i++)
                    {
                        folderName = folders[i];
                        subFolders = returnFolder.Folders;
                        returnFolder = subFolders[folderName] as Outlook.Folder;
                        if (subFolders != null) Marshal.ReleaseComObject(subFolders);
                    }
                }
            }
            catch
            {
                returnFolder = null;
            }
            finally
            {
                if (sessionFolders != null) Marshal.ReleaseComObject(sessionFolders);
                if (session != null) Marshal.ReleaseComObject(session);
                if (subFolders != null) Marshal.ReleaseComObject(subFolders);
            }
            return returnFolder;
        }

        private void adxImportInvoicesRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.Items folderItems = null;
            Outlook._PropertyAccessor propertyAccessor = null;
            Outlook.JournalItem invoiceItem = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                folderItems = currFolder.Items;
                propertyAccessor = currFolder.PropertyAccessor;
                object msgClass = null;
                try
                {
                    msgClass = propertyAccessor.GetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F");
                }
                catch { }

                if (msgClass != null && msgClass.Equals("IPM.Journal.Freshbooks.Invoice"))
                {
                    var api = new FreshbooksApi("Your Account Name", "Your Consumer Key");
                    api.UseLegacyToken("Your User Token");

                    var invoicesRequest = new InvoicesRequest();
                    invoicesRequest.PerPage = 100;
                    var invoicesResponse = api.Invoice.List(invoicesRequest);
                    foreach (var invoice in invoicesResponse.Invoices.InvoiceList)
                    {
                        invoiceItem = folderItems.Add(Outlook.OlItemType.olJournalItem) as Outlook.JournalItem;
                        invoiceItem.Body = invoice.Number;
                        invoiceItem.SetProperty("fb-clientid", invoice.Number, Outlook.OlUserPropertyType.olNumber);
                        invoiceItem.SetProperty("fb-invoicenumber", invoice.Number, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-status", invoice.Status, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-ponumber", invoice.PoNumber, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-amount", invoice.Amount, Outlook.OlUserPropertyType.olCurrency);
                        invoiceItem.SetProperty("fb-date", invoice.Date, Outlook.OlUserPropertyType.olDateTime);
                        invoiceItem.Save();
                        Marshal.ReleaseComObject(invoiceItem);
                    }
                }

            }
            finally
            {
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folderItems != null) Marshal.ReleaseComObject(folderItems);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void GetViewXML()
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.View currView = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;

                currView = currFolder.CurrentView;
                string viewXml = currView.XML;
            }
            finally
            {
                if (currView != null) Marshal.ReleaseComObject(currView);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

    }
}

